/**
 * inversify v.2.0.0-beta.2 - A lightweight IoC container written in TypeScript.
 * Copyright (c) 2015 Remo H. Jansen
 * MIT inversify.io/LICENSE
 * http://inversify.io
 */
import Metadata from "../planning/metadata";
import { tagParameter, tagProperty } from "./decorator_utils";
import * as METADATA_KEY from "../constants/metadata_keys";
function targetName(name) {
    return function (target, targetKey, index) {
        var metadata = new Metadata(METADATA_KEY.NAME_TAG, name);
        if (typeof index === "number") {
            return tagParameter(target, targetKey, index, metadata);
        }
        else {
            return tagProperty(target, targetKey, metadata);
        }
    };
}
export default targetName;
